def configuration(parent_package="", top_path=None):
    from numpy.distutils.misc_util import Configuration

    config = Configuration("bolero", parent_package, top_path)
    config.set_options(ignore_setup_xxx_py=True,
                       assume_default_configuration=True,
                       delegate_options_to_subpackages=True,
                       quiet=True)
    config.add_subpackage("behavior_search")
    config.add_subpackage("controller")
    config.add_subpackage("datasets")
    config.add_subpackage("environment")
    config.add_subpackage("optimizer")
    config.add_subpackage("representation")
    config.add_subpackage("utils")
    config.add_subpackage("wrapper")
    return config

if __name__ == "__main__":
    from numpy.distutils.core import setup
    setup(**configuration(top_path="").todict())
